
; DLL creation example

format PE GUI 4.0 DLL
entry DllEntryPoint

include 'win32a.inc'

section '.text' code readable executable

proc DllEntryPoint hinstDLL,fdwReason,lpvReserved
	mov    eax,[fdwReason]
	cmp    eax,DLL_PROCESS_ATTACH
	jne    .finish
	invoke CreateThread,NULL,NULL,ShowMessage,NULL,NULL,ThreadID
	mov    [hThread],eax
	.finish:
	mov	eax,TRUE
	ret
endp

proc ShowMessage
     invoke MessageBox,NULL,_title,_text,MB_OK
     ret
endp

section '.data' data readable writeable

  _title db 'Window Title',0
  _text db 'Window Message.',0

section '.bss' readable writeable

  ThreadID dd ?
  hThread dd ?

section '.idata' import data readable writeable

  library kernel,'KERNEL32.DLL',\
	  user,'USER32.DLL'

  import kernel,\
	 CreateThread,'CreateThread'

  import user,\
	 MessageBox,'MessageBoxA'

section '.edata' export data readable

  export 'DLLTest.DLL',\
	 ShowMessage,'ShowMessage'

section '.reloc' fixups data discardable